{############################################################################
#                                                                           #
#  SLX Cube V3 :: 3D Cube Screen Saver                                      #
#  Copyright (C) 2000-2005  N.G van der Westhuizen                          #
#                                                                           #
#    This program is free software; you can redistribute it and/or modify   #
#    it under the terms of the GNU General Public License as published by   #
#    the Free Software Foundation; either version 2 of the License, or      #
#    (at your option) any later version.                                    #
#                                                                           #
#    This program is distributed in the hope that it will be useful,        #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#    GNU General Public License for more details.                           #
#                                                                           #
#    You should have received a copy of the GNU General Public License      #
#    along with this program; if not, write to the Free Software            #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston,                  #
#    MA  02111-1307  USA                                                    #
#    http://www.fsf.org                                                     #
#                                                                           #
#                                                                           #
#  N.G van der Westhuizen                                                   #
#  P.O Box 563, Rosettenville, JHB, 2130, South-Africa                      #
#  http://www.slx.za.net                                                    #
#  info@slx.za.net                                                          #
#                                                                           #
############################################################################}

unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, ExtDlgs, Spin, INIFiles, ComCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel1: TPanel;
    Image8: TImage;
    Image1: TImage;
    Panel2: TPanel;
    Image2: TImage;
    Panel3: TPanel;
    Image3: TImage;
    Panel4: TPanel;
    Image4: TImage;
    Panel5: TPanel;
    Image5: TImage;
    Panel6: TPanel;
    Image6: TImage;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image2DblClick(Sender: TObject);
    procedure Image3DblClick(Sender: TObject);
    procedure Image4DblClick(Sender: TObject);
    procedure Image5DblClick(Sender: TObject);
    procedure Image6DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   Procedure Startup_Stuff;
   Procedure Read_INI_File;
   Procedure Save_INI_File;

   Procedure Assign_Default_Image(Image: Integer);
   Procedure Assign_Image(Image: Integer);
  end;

Const
 INI_FILE_NAME = 'slx_cube.ini';

var
 Form2: TForm2;
 INI_File: TiniFile;
 INI_FileName: String;
 Image_List: Array[1..6] of String;

implementation

{$R *.DFM}

procedure TForm2.FormActivate(Sender: TObject);
begin
 ShowWindow(Application.Handle, SW_HIDE);     //This Should Hides it from the Task Bar
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
 Startup_Stuff;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
 Close;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
 Save_INI_File;
 Close;
end;

Procedure TForm2.Startup_Stuff;
Var
 Loop: Integer;
Begin
 Read_INI_File;

 For Loop := 1 to 6 do
  Begin
   if not FileExists(Image_List[Loop]) then
    Assign_Default_Image(Loop)
   else
    Case Loop of
     1: Image1.Picture.LoadFromFile (Image_List[Loop]);
     2: Image2.Picture.LoadFromFile (Image_List[Loop]);
     3: Image3.Picture.LoadFromFile (Image_List[Loop]);
     4: Image4.Picture.LoadFromFile (Image_List[Loop]);
     5: Image5.Picture.LoadFromFile (Image_List[Loop]);
     6: Image6.Picture.LoadFromFile (Image_List[Loop]);
    end;
  end;
end;

Procedure TForm2.Read_INI_File;
Var
 Loop: Integer;
Begin
 INI_FileName := ExtractFileDir(Paramstr(0)) + '\' + INI_FILE_NAME;
 INI_File := TiniFile.Create (INI_FileName);

 SpinEdit1.Value := INI_File.ReadInteger('Time', 'Delay', 1);

 For Loop := 1 to 6 do
  Image_List[Loop] := INI_File.ReadString('Images', IntToStr(Loop), '');

 TrackBar1.Position := INI_File.ReadInteger('Scale', 'Scale', 5);

 INI_File.Free;
 Application.ProcessMessages;
end;

Procedure TForm2.Save_INI_File;
Var
 Loop: Integer;
Begin
 INI_FileName := ExtractFileDir(Paramstr(0)) + '\' + INI_FILE_NAME;
 INI_File := TiniFile.Create (INI_FileName);

 INI_File.WriteInteger('Time', 'Delay', SpinEdit1.Value);

 For Loop := 1 to 6 do
  INI_File.WriteString('Images', IntToStr(Loop), Image_List[Loop]);

 INI_File.WriteInteger('Scale', 'Scale', TrackBar1.Position);

 INI_File.Free;
end;

Procedure TForm2.Assign_Default_Image(Image: Integer);
Begin
 Case Image of
  1: Image1.Picture.Assign (Image8.Picture);
  2: Image2.Picture.Assign (Image8.Picture);
  3: Image3.Picture.Assign (Image8.Picture);
  4: Image4.Picture.Assign (Image8.Picture);
  5: Image5.Picture.Assign (Image8.Picture);
  6: Image6.Picture.Assign (Image8.Picture);
 end;
end;

procedure TForm2.Image1DblClick(Sender: TObject);
begin
 Assign_Image(1);
end;

procedure TForm2.Image2DblClick(Sender: TObject);
begin
 Assign_Image(2);
end;

procedure TForm2.Image3DblClick(Sender: TObject);
begin
 Assign_Image(3);
end;

procedure TForm2.Image4DblClick(Sender: TObject);
begin
 Assign_Image(4);
end;

procedure TForm2.Image5DblClick(Sender: TObject);
begin
 Assign_Image(5);
end;

procedure TForm2.Image6DblClick(Sender: TObject);
begin
 Assign_Image(6);
end;

Procedure TForm2.Assign_Image(Image: Integer);
Begin
 if OpenPictureDialog1.Execute then
  Try
   Case Image of
    1: Image1.Picture.LoadFromFile (OpenPictureDialog1.FileName);
    2: Image2.Picture.LoadFromFile (OpenPictureDialog1.FileName);
    3: Image3.Picture.LoadFromFile (OpenPictureDialog1.FileName);
    4: Image4.Picture.LoadFromFile (OpenPictureDialog1.FileName);
    5: Image5.Picture.LoadFromFile (OpenPictureDialog1.FileName);
    6: Image6.Picture.LoadFromFile (OpenPictureDialog1.FileName);
   end;

   Image_List[Image] := OpenPictureDialog1.FileName;
  Except
   ShowMessage('Error Opening File: ' + ExtractFileName(OpenPictureDialog1.FileName));
  end;
end;

end.
